﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            // QueueUserWorkItem 으로 별도의 스레드에서 작업 수행
            ThreadPool.QueueUserWorkItem(
                (obj) =>
                {
                    Console.WriteLine("process workitem");
                }, null);

            // Task 로 별도의 스레드에서 작업 수행
            Task task1 = new Task(
                () =>
                {
                    Console.WriteLine("process taskitem");
                });

            task1.Start();

            Task task2 = new Task(
                (obj) =>
                {
                    Console.WriteLine("process taskitem(obj)");
                }, null);

            task2.Start();

            Task taskSleep = new Task(() => { Thread.Sleep(5000); });
            taskSleep.Start();
            taskSleep.Wait();

            Task.Factory.StartNew(
                () => { Console.WriteLine("process taskitem"); });

            Task.Factory.StartNew(
                (obj) => { Console.WriteLine("process taskitem(obj)"); }, null);

Task<int> task = new Task<int>(
    () =>
    {
        Random rand = new Random((int)DateTime.Now.Ticks);
        // 1부터 50000까지의 숫자를 무작위로 섞은 다음
        int[] list = Enumerable.Range(1, 50000).OrderBy(o => rand.Next()).ToArray();

        // 목록에서 가장 작은 숫자를 반환 (당연히 1)
        return list.Min();
    }
);

task.Start();
task.Wait();
Console.WriteLine("목록 중 가장 작은 값: " + task.Result);

Task<int> taskReturn = Task.Factory.StartNew<int>(() => 1);
taskReturn.Wait();
Console.WriteLine(taskReturn.Result);
            




            Console.ReadLine();
        }

    }
}
